﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=9.85
@EndOfDesignText@
Sub Class_Globals
	Private Root As B4XView 'ignore
	Private fx As JFX
	Private xui As XUI 'ignore
	Private btnSend As B4XView
	Private btnConnect As Button
	Private connected As Boolean
	Private client As Socket
	Public server As ServerSocket
	Private astream As AsyncStreams
	Private working As Boolean = True
	Private lblStatus, lblCommand, lblResponse As B4XView
	Private lblMyIp As B4XView
	Private txtIP As B4XFloatTextField 
	Private txtPort, txtAddr As B4XFloatTextField
	Private txtCommand As B4XFloatTextField
	Private txtConsole As TextArea
	Private rbShowHex, rbShowAscii As B4XRadioButton
	Private swNoParity, swNoChecksum As B4XSwitch
	'Type MyMessage( Name As String, Age As Int, Image() As Byte )
	
	' for virtual COM port over Ethernet
	Dim WIFI_STX As Byte = Asc("!")	' 33 0x21
	Dim WIFI_ETX As Byte = Asc("$")	' 36 0x24
	Dim WIFI_ACK As Byte = Asc("%")	' 37 0x25
	Dim WIFI_NAK As Byte = Asc("&")	' 38 0x26

	' for normal 8 bit SABus
	Dim SA_STX As Byte = 2
	Dim SA_ETX As Byte = 3
	Dim SA_ACK As Byte = 6
	Dim SA_NAK As Byte = 21
	
	Dim STX As Byte = SA_STX
	Dim ETX As Byte = SA_ETX
	Dim ACK As Byte = SA_ACK
	Dim NAK As Byte = SA_NAK
	
	Type SettingType( Selected As Boolean )
	Dim cmNoParity As SettingType
	Dim cmNoChecksum As SettingType
	
	Private mapSettings As Map
	
	Dim AppName As String = "tcpClient"
End Sub ' Class_Globals

'You can add more parameters here.
Public Sub Initialize
	cmNoChecksum.Initialize
	cmNoChecksum.Selected = False
	cmNoParity.Initialize
	cmNoParity.Selected = False
End Sub ' Initialize

' Wireshark: Use this display filter:
'ip.addr == 192.168.1.10 && !(tcp.flags.ack && tcp.len <= 1)

'This event will be called once, before the page becomes visible.
Private Sub B4XPage_Created( Root1 As B4XView )
	Root = Root1
	'load the layout to Root
	Root.LoadLayout("1")
	B4XPages.SetTitle( Me, AppName )
	
	For Each txt As B4XFloatTextField In Array( txtIP, txtAddr, txtPort, txtCommand )
		txt.LargeLabelTextSize = 15
		txt.SmallLabelTextSize = 12
		txt.Update
	Next
	txtIP.Text = "192.168.1.10"
	txtPort.Text = "8899"
	txtAddr.Text = "0"
	txtCommand.Text = "0"
	rbShowAscii.Checked = True
	btnConnect.style = "-fx-background-color: red"
	UpdateState( False )
	mapSettings.Initialize
	SettingsGet
End Sub ' B4XPage_Created()

Sub B4XPage_Resize( Width As Int, Height As Int )
	'cvs.Resize(pnlCanvas.Width, pnlCanvas.Height)
End Sub ' B4XPage_Resize()

Private Sub ListenForConnections
	Do While working
		server.Listen
		Wait For Server_NewConnection (Successful As Boolean, NewSocket As Socket)
		If Successful Then
			CloseExistingConnection
			client = NewSocket
			astream.Initialize( client.InputStream, client.OutputStream, "astream" )
			UpdateState( True )
		End If
	Loop
End Sub ' ListenForConnections

Sub CloseExistingConnection
	If astream.IsInitialized Then astream.Close
	If client.IsInitialized Then client.Close
	UpdateState( False )
	btnConnect.style = "-fx-background-color: red"
End Sub ' CloseExistingConnection

Sub AStream_Error
	Log( "AStream_Error: " & LastException.Message )
	UpdateState( False )
End Sub ' AStream_Error

Sub AStream_Terminated
	Log( "AStream_Terminated: " & LastException.Message )
	UpdateState( False )
End Sub ' AStream_Terminated

Sub UpdateState( NewState As Boolean )
	connected = NewState
	btnSend.Enabled = connected
	If connected Then
		btnConnect.Text = "Disconnect"
		lblStatus.Text = "Connected"
	Else
		btnConnect.Text = "Connect"
		lblStatus.Text = "Disconnected"
	End If
	lblMyIp.Text = "My ip: " & server.GetMyIP
End Sub ' UpdateState()

Sub AStream_NewData( Buffer() As Byte )
	Dim outbuf( Buffer.Length ) As Byte, out As String
	For i=0 To  Buffer.Length-1
		outbuf(i) = Bit.And( Buffer(i), 127 )
		If i > 0 And i < Buffer.Length-1 Then
			out = out & Chr( outbuf(i))
		End If
	Next
	'out = BytesToString( outbuf, 0, outbuf.Length, "UTF8" )
	If rbShowAscii.Checked Then
		lblResponse.Text = printSABus( outbuf )
	Else
		lblResponse.Text = " " & printHex( Buffer )
	End If
	AddText( out )
End Sub ' AStream_NewData()

Private Sub ConnectToServer( Host As String )
	Log( "Trying to connect to: " & Host )
	CloseExistingConnection
	Dim client As Socket
	client.Initialize( "client" )
	client.Connect( Host, txtPort.text, 10000 )
	Wait For Client_Connected( Successful As Boolean )
	If Successful Then
		astream.Initialize( client.InputStream, client.OutputStream, "astream" )
		UpdateState( True )
		btnConnect.style = "-fx-background-color: lime"
	Else
		Log( "Failed to connect: " & LastException )
		btnConnect.style = "-fx-background-color: red"
	End If
End Sub ' ConnectToServer()

Private Sub Disconnect
	CloseExistingConnection
End Sub ' Disconnect

Sub btnSend_Click
	SendCmdAt( txtCommand.Text, txtAddr.Text )
End Sub ' btnSend_Click

' SendCmd to specified address adds STX, ETX and Checksum
Sub SendCmdAt( cmd As String, addr_in As String )
	Dim buffer(), cs As Byte
	Dim msg, addr As String
	Dim i As Int

	If connected = False Then 
		Log( "Not connected" )
		Return
	End If
	
	If (0+addr_in) > 9 Then
		addr = Chr( Asc("9") + (addr_in - 9) )
	Else
		addr = addr_in
	End If
	msg = Chr( STX ) & addr & cmd & Chr( ETX ) ' STX = Chr( 2 )
	'LastCmd = cmd
	buffer = msg.GetBytes( "UTF8" )
	
	' test of doParity() and printBits() functions
	'For i=0 To 10
	'	Log( i & ", " & printBits( doParity( i )))
	'Next
	
	cs = 0
	Dim outbuf( buffer.Length+1 ) As Byte
	For i=0 To buffer.Length-1
		If cmNoParity.Selected = False Then
			' set parity bit
			buffer(i) = doParity( buffer(i))
		End If
		cs = Bit.Xor( cs, buffer(i))
		outbuf(i) = buffer(i)
	Next
	If cmNoParity.Selected = False Then
		outbuf(i) = doParity( cs )
	End If
	Log( "Sending: <STX>" & msg.SubString2(1, msg.Length-1) & "<ETX> (" & printHex( outbuf ) & ")")

	AddText( "Command >" & cmd )

	'TimeOutTimer.Enabled = False ' make sure to restart the timer
	'TimeOutTimer.Enabled = True
	astream.Write( outbuf )

	If rbShowAscii.Checked Then
		lblCommand.Text = printSABus( outbuf )
	Else
		lblCommand.Text = " " & printHex( outbuf )
	End If
End Sub ' SendCmdAt()

Sub btnConnect_Click
	If connected = False Then
		If txtIP.Text.Length = 0 Then
			xui.MsgboxAsync( "Please enter the server ip address.", "" )
			Return
		Else
			ConnectToServer( txtIP.Text )
		End If
		SettingsSave
	Else
		Disconnect
	End If
End Sub ' btnConnect_Click

Sub btnClear_Click
	txtConsole.Text = ""
End Sub ' btnClear_Click

Sub DoProtocol( WiFiSelected As Boolean )
	If WiFiSelected = True Then
		astream.Close
		STX = WIFI_STX
		ETX = WIFI_ETX
		ACK = WIFI_ACK
		NAK = WIFI_NAK
	Else
		STX = SA_STX
		ETX = SA_ETX
		ACK = SA_ACK
		NAK = SA_NAK
	End If
End Sub ' DoProtocol()


Sub printBits( c As Byte ) As String
	Dim out As String
	For i=7 To 0 Step -1
		out = out & Chr( Bit.And( Bit.ShiftRight(c, i), 1) + Asc("0"))
		If i = 4 Then out = out & " "
	Next
	Return out
End Sub ' printBits()

Sub printHex( b() As Byte ) As String
	Dim out As String
	For i=0 To b.Length-2
		out = out & "0x" & Bit.ToHexString( Bit.And( b(i), 0xFF )).ToUpperCase & ", "
	Next
	out = out & "0x" & Bit.ToHexString( Bit.And( b(i), 0xFF )).ToUpperCase
	Return out
End Sub ' printHex()

Sub doParity( i As Byte ) As Byte
	Dim k As Byte
	k = i
	k = Bit.Xor( k, k*16 )
	k = Bit.Xor( k, k*4 )
	k = Bit.Xor( k, k*2 )
	k = Bit.And( k, 0x80 )
	k = Bit.Or( i, k )
	Return Bit.And( k, 0xFF )
End Sub ' doParity

Sub printSABus(b() As Byte ) As String
	Dim i As Int, out As String
	For i = 0 To b.length - 2
		b(i) = Bit.And(b(i), 127)
		If i = 1 Then
			' address
			out = out & "<ADDR:" & Chr(b(i)) & ">"
		Else If i = 2 Then
			out = out & "<CMD:" & Chr(b(i)) & ">"
		Else
			Select Case b(i)
				Case STX
					out = out & "<STX>"
				Case ACK
					out = out & "<ACK>"
				Case NAK
					out = out & "<NAK>"
				Case ETX
					out = out & "<ETX>"
				Case Else
					out = out & Chr(b(i))
			End Select
		End If
	Next
	out = out & "<CHKSUM:" & b(i) & ">"
	Return out
End Sub ' printSABus()

' add a text string to the end of txtConsole.Text, shift up to show most recent text
' prune if txtConsole.Text gets longer than 32,000 characters
Sub AddText( s As String )
	Dim i As Int
	If txtConsole.Text.Length > 32000 Then
		txtConsole.Text = txtConsole.Text.SubString( 20000 )
		i = txtConsole.Text.IndexOf( CRLF )
		If txtConsole.Text.SubString2( i+1, i+2 ) = Chr( 10 ) Then i = i+1 ' if adding a Unix terminated string
		txtConsole.Text = txtConsole.Text.SubString( i+1 )
	End If
	'If TimeStamps Then
	'	DateTime.TimeFormat = "HH:mm:ss"
	'	s = DateTime.Time( DateTime.Now ) & " " & s
	'End If
	If txtConsole.Text.Length > 0 Then
		txtConsole.Text = txtConsole.Text & CRLF & s
	Else
		txtConsole.Text = s
	End If
	CallSubDelayed( Me, "AddTextScrollDown" )
End Sub ' AddText()

Sub AddTextScrollDown
	Sleep( 100 )
	txtConsole.ScrollTopPosition = txtConsole.Text.Length * 2 ' 1000000
End Sub ' AddTextScrollDown

Sub SettingsGet
	If File.Exists( File.DirData( AppName ), AppName & ".cfg" ) = True Then
		mapSettings = File.ReadMap( File.DirData( AppName ), AppName & ".cfg" )
		txtAddr.Text = GetMapValue( mapSettings, "SABusAddr", 0 )
		txtIP.text = GetMapValue( mapSettings, "IPAddress", "192.168.1.10" )
		txtPort.text = GetMapValue( mapSettings, "IPPort", 8081 )
	End If
End Sub ' SettingsGet

Sub GetMapValue( map As Map, key As String, default As Object ) As Object
	Dim s As String, i As Int, b As Boolean, f As Float, l As Long, obj As Object
	Try
		If default Is String Then
			s = map.GetDefault( key, default )
			obj = s
		Else If default Is Int Then
			i = map.GetDefault( key, default )
			obj = i
		Else If default Is Boolean Then
			b = map.GetDefault( key, default )
			obj = b
		Else If default Is Float Then
			f = map.GetDefault( key, default )
			obj = f
		Else If default Is Long Then
			l = map.GetDefault( key, default )
			obj = l
		End If
	Catch
		obj = default
		'Log(LastException)
	End Try
	Return obj
End Sub ' GetMapValue()

Sub SettingsSave
	mapSettings.Clear
	mapSettings.Put( "SABusAddr", txtAddr.Text )
	mapSettings.Put( "IPAddress", txtIP.Text )
	mapSettings.Put( "IPPort", txtPort.Text )
	File.WriteMap( File.DirData( AppName ), AppName & ".cfg", mapSettings )
End Sub ' SettingsSave

